Scriptname TweakFollowerDiagnostics extends Quest

; Edited Vanilla

Quest Property DialogueAnimalTrainers Auto ; TweakAnimals
Quest Property DialogueFollower Auto ; TweakDFScript
Quest Property pHirelingQuest Auto ; TweakHirelingQuest
Quest Property stables Auto ; TweakStables
Quest Property FreeformSkyhavenTempleA Auto ; TweakFreeformSkyHavenTempleAScript
Quest Property FreeformSkyhavenTempleB Auto ; TweakFreeformSkyHavenTempleAScript
Quest Property RelationshipMarriageWedding Auto ; TweakQF_RelationshipMarriageWedding

; Quest Property DialogueFavorGeneric Auto ; ** Cant Check
; Quest Property DarkBrotherhood Auto ; ** Cant Check
; Quest Property VoicePowers Auto ; ** Cant Check

; Custom
Quest Property TweakBackPack Auto
Quest Property TweakCheck4Dialogue Auto
Quest Property TweakCheck4Idle Auto
Quest Property TweakDawnGuard Auto
Quest Property TweakDragonBorn Auto
Quest Property TweakFixLydia Auto
Quest Property TweakFollower Auto
Quest Property TweakImportFollower Auto
Quest Property TweakLevelMonitor Auto
Quest Property TweakMonitorPlayer Auto
Quest Property TweakPotentialFollower Auto
Quest Property pTweakThreadMaster Auto
Quest Property TweakThreadWorker1 Auto
Quest Property TweakThreadWorker2 Auto
Quest Property TweakThreadWorker3 Auto
Quest Property TweakThreadWorker4 Auto
Quest Property TweakTraps Auto
Quest Property TweakVampireKeyword Auto

GlobalVariable Property TweakAIMustSheathe Auto
GlobalVariable Property TweakAINeedCloseIdle Auto
GlobalVariable Property TweakAINotWhenTalking Auto
GlobalVariable Property TweakAISettleProbability Auto
GlobalVariable Property TweakAITimeMode Auto
GlobalVariable Property TweakDiagnosticsMode Auto
GlobalVariable Property TweakExtraDamage Auto
GlobalVariable Property TweakFollowerCount Auto
GlobalVariable Property TweakHorsesOblivious Auto
GlobalVariable Property TweakLimitFollowers Auto
GlobalVariable Property TweakMoreInteractive Auto
GlobalVariable Property TweakPlayerSettled Auto
GlobalVariable Property TweakRechargeThreshold Auto
GlobalVariable Property TweakRootBackPack Auto
GlobalVariable Property TweakStealthActive Auto
GlobalVariable Property TweakThreadCount Auto
GlobalVariable Property TweakThreadsDone Auto

FormList Property TweakCombatOverridePackageList Auto

Keyword Property pWeapTypeGreatsword Auto
Keyword Property pWeapTypeBattleAxe Auto
Keyword Property pArmorShield Auto
Keyword Property pWeapTypeStaff Auto
Keyword Property pWeapTypeBow Auto

Package Property pTweakFollowerSandbox Auto
Package Property pTweakFollowerNonAggressiveWaitPackage Auto
Package Property pTweakFollowerWaitPackage Auto
Package Property pTweakFollowerNonAggressivePackage Auto
Package Property pTweakFollowerPackage Auto
Package Property pTweakFollowerPackageGetOnHorse Auto
Package Property pTweakFollowerPackageHorse Auto

Package Property TweakArcherPackage Auto
Package Property TweakArcherPackageExternal Auto
Package Property TweakArcherPackageExternalLow Auto
Package Property TweakArcherPackageLow Auto
Package Property TweakBeastPackage Auto
Package Property TweakVLPackage Auto
Package Property pTweakDualPackage Auto
Package Property TweakDualPackageExterior Auto
Package Property TweakDualPackageExteriorLow Auto
Package Property TweakDualPackageLow Auto
Package Property TweakGeneralPackage Auto
Package Property TweakGeneralPackageExterior Auto
Package Property TweakGeneralPackageExteriorLow Auto
Package Property TweakGeneralPackageLow Auto
Package Property TweakMagePackage Auto
Package Property TweakMagePackageExterior Auto
Package Property TweakMagePackageExteriorLow Auto
Package Property TweakMagePackageLow Auto
Package Property TweakRangerPackage Auto
Package Property TweakRangerPackageExterior Auto
Package Property TweakRangerPackageExteriorLow Auto
Package Property TweakRangerPackageLow Auto
Package Property TweakSpellSwordPackage Auto
Package Property TweakSpellSwordPackageExterior Auto
Package Property TweakSpellSwordPackageExteriorLow Auto
Package Property TweakSpellSwordPackageLow Auto
Package Property TweakSwordAndShieldPackage Auto
Package Property TweakSwordAndShieldPackageExterior Auto
Package Property TweakSwordAndShieldPackageExteriorLow Auto
Package Property TweakSwordAndShieldPackageLow Auto
Package Property TweakTwoHandedPackage Auto
Package Property TweakTwoHandedPackageExterior Auto
Package Property TweakTwoHandedPackageExteriorLow Auto
Package Property TweakTwoHandedPackageLow Auto

Function GetQuestInfo()

	String str = "TweakBackPack ["
	if TweakBackPack.IsRunning()
		str += "쒆]\n"
    Else
		str += "~]\n"
	endif
	str += "TweakCheck4Dialogue ["
	if TweakCheck4Dialogue.IsRunning()
		str += "쒆]\n"
    Else		
		str += "~]\n"
	endif
	str += "TweakCheck4Idle ["
	if TweakCheck4Idle.IsRunning()
		str += "쒆]\n"
    Else		
		str += "~]\n"
	endif
	str += "TweakDawnGuard ["
	if TweakDawnGuard.IsRunning()
		str += "쒆]\n"
    Else		
		str += "~]\n"
	endif
	str += "TweakDragonBorn ["
	if TweakDragonBorn.IsRunning()
		str += "쒆]\n"
    Else		
		str += "~]\n"
	endif
	str += "TweakFixLydia ["
	if TweakFixLydia.IsRunning()
		str += "쒆]\n"
    Else		
		str += "~]\n"
	endif
	str += "TweakFollower ["
	if TweakFollower.IsRunning()
		str += "쒆]\n"
    Else		
		str += "~]\n"
	endif
	str += "TweakImportFollower ["
	if TweakImportFollower.IsRunning()
		str += "쒆]\n"
    Else		
		str += "~]\n"
	endif
	str += "TweakLevelMonitor ["
	if TweakLevelMonitor.IsRunning()
		str += "쒆]\n"
    Else		
		str += "~]\n"
	endif

	Debug.MessageBox(str)
	Utility.wait(0.1)
	
	str = "TweakMonitorPlayer ["
	if TweakMonitorPlayer.IsRunning()
		str += "쒆]\n"
    Else		
		str += "~]\n"
	endif
	str += "TweakPotentialFollower ["
	if TweakPotentialFollower.IsRunning()
		str += "쒆]\n"
    Else		
		str += "~]\n"
	endif	
	str += "TweakThreadMaster ["
	if pTweakThreadMaster.IsRunning()
		str += "쒆]\n"
    Else		
		str += "~]\n"
	endif
	str += "TweakThreadWorker1 ["
	if TweakThreadWorker1.IsRunning()
		str += "쒆]\n"
    Else		
		str += "~]\n"
	endif
	str += "TweakThreadWorker2 ["
	if TweakThreadWorker2.IsRunning()
		str += "쒆]\n"
    Else		
		str += "~]\n"
	endif
	str += "TweakThreadWorker3 ["
	if TweakThreadWorker3.IsRunning()
		str += "쒆]\n"
    Else		
		str += "~]\n"
	endif
	str += "TweakThreadWorker4 ["
	if TweakThreadWorker4.IsRunning()
		str += "쒆]\n"
    Else		
		str += "~]\n"
	endif
	str += "TweakTraps ["
	if TweakTraps.IsRunning()
		str += "쒆]\n"
    Else		
		str += "~]\n"
	endif
	str += "TweakVampireKeyword ["
	if TweakVampireKeyword.IsRunning()
		str += "쒆]\n"
    Else		
		str += "~]\n"
	endif

	Debug.MessageBox(str)
	Utility.wait(0.1)
	
	str = "DialogueAnimalTrainers ["
	if DialogueAnimalTrainers As TweakAnimals
		str += "AFTǗ]\n"
    Else
		str += "Ǘ]\n"
	endif
	str += "DialogueFollower ["
	if DialogueFollower As TweakDFScript
		str += "AFTǗ]\n"
    Else
		str += "Ǘ]\n"
	endif
	str += "HirelingQuest ["
	if pHirelingQuest As TweakHirelingQuest
		str += "AFTǗ]\n"
    Else
		str += "Ǘ]\n"
	endif
	str += "Stables ["
	if stables As TweakStables
		str += "AFTǗ]\n"
    Else
		str += "Ǘ]\n"
	endif
	str += "FreeformSkyhavenTempleA ["
	if FreeformSkyhavenTempleA As TweakFreeformSkyHavenTempleAScript
		str += "AFTǗ]\n"
    Else
		str += "Ǘ]\n"
	endif
	str += "FreeformSkyhavenTempleB ["
	if FreeformSkyhavenTempleB As TweakFreeformSkyHavenTempleAScript
		str += "AFTǗ]\n"
    Else
		str += "Ǘ]\n"
	endif

	Debug.MessageBox(str)
	Utility.wait(0.1)

EndFunction

Function GetGlobalInfo()
	String str = "TweakAIMustSheathe [" + TweakAIMustSheathe.GetValueInt() + "]\n"
	str += "TweakAINeedCloseIdle [" + TweakAINeedCloseIdle.GetValueInt() + "]\n"
	str += "TweakAINotWhenTalking [" + TweakAINotWhenTalking.GetValueInt() + "]\n"
	str += "TweakAISettleProbability [" + TweakAISettleProbability.GetValueInt() + "]\n"
	str += "TweakAITimeMode [" + TweakAITimeMode.GetValueInt() + "]\n"
	str += "TweakDiagnosticsMode [" + TweakDiagnosticsMode.GetValueInt() + "]\n"
	str += "TweakExtraDamage [" + TweakExtraDamage.GetValueInt() + "]\n"
	str += "TweakFollowerCount [" + TweakFollowerCount.GetValueInt() + "]\n"
	str += "TweakHorsesOblivious [" + TweakHorsesOblivious.GetValueInt() + "]"
	
	Debug.MessageBox(str)
	Utility.wait(0.1)

	str = "TweakLimitFollowers [" + TweakLimitFollowers.GetValueInt() + "]\n"
	str += "TweakMoreInteractive [" + TweakMoreInteractive.GetValueInt() + "]\n"
	str += "TweakPlayerSettled [" + TweakPlayerSettled.GetValueInt() + "]\n"
	str += "TweakRechargeThreshold [" + TweakRechargeThreshold.GetValueInt() + "]\n"
	str += "TweakRootBackPack [" + TweakRootBackPack.GetValueInt() + "]\n"
	str += "TweakStealthActive [" + TweakStealthActive.GetValueInt() + "]\n"
	str += "TweakThreadCount [" + TweakThreadCount.GetValueInt() + "]\n"
	str += "TweakThreadsDone [" + TweakThreadsDone.GetValueInt() + "]\n"
	
	Debug.MessageBox(str)
	Utility.wait(0.1)

EndFunction

Function Validate()
	int issuecount = 0
	String str = ""
	String estr = ""
	
	if !TweakBackPack.IsRunning()
		issuecount += 1
		estr += "TweakBackPack͓삵Ă܂\n"
	endif
	if !TweakFollower.IsRunning()
		issuecount += 1
		estr += "TweakFollower͓삵Ă܂(ň̎)\n"
	endif
	if !TweakImportFollower.IsRunning()
		issuecount += 1
		estr += "TweakImportFollower삵Ă܂\n"
	endif
	if !TweakMonitorPlayer.IsRunning()
		issuecount += 1
		estr += "TweakMonitorPlayer삵Ă܂([Ȏ)\n"
	endif
	if !TweakPotentialFollower.IsRunning()
		issuecount += 1
		estr += "TweakPotentialFollower삵Ă܂\n"
	endif
	
	if !(DialogueAnimalTrainers As TweakAnimals)
		issuecount += 1
		estr += "MODDialogueAnimalTrainersǗĂ܂\n"
	endif
	if !(DialogueFollower As TweakDFScript)
		issuecount += 1
		estr += "MODDialogueFolloweǗĂ܂\n"
	endif
	
	if !(pHirelingQuest As TweakHirelingQuest)
		issuecount += 1
		estr += "MODHirelingQuestǗĂ܂\n"
	endif
	
	if !(stables As TweakStables)
		issuecount += 1
		estr += "MODStables QuestǗĂ܂\n"
	endif

	if !(FreeformSkyhavenTempleA As TweakFreeformSkyHavenTempleAScript)
		issuecount += 1
		estr += "MODFreeformSkyhavenTempleAǗĂ܂\n"
	endif
	
	if !(FreeformSkyhavenTempleB As TweakFreeformSkyHavenTempleAScript)
		issuecount += 1
		estr += "MODFreeformSkyhavenTempleBǗĂ܂\n"
	endif	
	
	if (0 == issuecount)
		Debug.MessageBox("Quest̖肪 [" + issuecount + "] o܂")
		Utility.wait(0.1)
	else
		str = "Quest̖肪 [" + issuecount + "] o܂:\n\n"
		str += estr
		Debug.MessageBox(str)
		Utility.wait(0.1)
	endif

	; Invalid value checks:
	issuecount = 0
	estr = ""
	
	if TweakAIMustSheathe.GetValue() < 0.0 || TweakAIMustSheathe.GetValue() > 1.0
		issuecount += 1
		estr += "TweakAIMustSheathe01łׂł\n"
	EndIf
	if TweakAINeedCloseIdle.GetValue() < 0.0 || TweakAINeedCloseIdle.GetValue() > 1.0
		issuecount += 1
		estr += "TweakAINeedCloseIdle01łׂł\n"
	EndIf
	if TweakAINotWhenTalking.GetValue() < 0.0 || TweakAINotWhenTalking.GetValue() > 1.0
		issuecount += 1
		estr += "TweakAINotWhenTalking01łׂł\n"
	EndIf
	if TweakExtraDamage.GetValue() < 0.0 || TweakExtraDamage.GetValue() > 1.0
		issuecount += 1
		estr += "TweakExtraDamage01łׂł\n"
	EndIf
	if TweakHorsesOblivious.GetValue() < 0.0 || TweakHorsesOblivious.GetValue() > 1.0
		issuecount += 1
		estr += "TweakHorsesOblivious01łׂł\n"
	EndIf
	if TweakLimitFollowers.GetValue() < 0.0 || TweakLimitFollowers.GetValue() > 1.0
		issuecount += 1
		estr += "TweakLimitFollowers01łׂł\n"
	EndIf
	if TweakMoreInteractive.GetValue() < 0.0 || TweakMoreInteractive.GetValue() > 1.0
		issuecount += 1
		estr += "TweakMoreInteractive01łׂł\n"
	EndIf
	if TweakPlayerSettled.GetValue() < 0.0 || TweakPlayerSettled.GetValue() > 1.0
		issuecount += 1
		estr += "TweakPlayerSettled01łׂł\n"
	EndIf
	if TweakRootBackPack.GetValue() < 0.0 || TweakRootBackPack.GetValue() > 1.0
		issuecount += 1
		str += "TweakRootBackPack01łׂł\n"
	EndIf
	if TweakStealthActive.GetValue() < 0.0 || TweakStealthActive.GetValue() > 1.0
		issuecount += 1
		estr += "TweakStealthActive01łׂł\n"
	EndIf
	if TweakFollowerCount.GetValue() < 0.0 ||  TweakFollowerCount.GetValue() > 5.0
		issuecount += 1
		estr += "TweakFollowerCount0ȏ5ȉłׂł\n"
	EndIf
	if TweakRechargeThreshold.GetValue() <= 0
		issuecount += 1
		estr += "TweakRechargeThreshold0ȏłׂł\n"
	EndIf
	if TweakAITimeMode.GetValue() < 0.0 || TweakAITimeMode.GetValue() > 2.0
		issuecount += 1
		estr += "TweakAITimeMode0ȏ2ȉłׂł\n"
	EndIf
	
	if (0 == issuecount) 
		Debug.MessageBox("Global Variable̖肪 [" + issuecount + "] o܂")
		Utility.wait(0.1)
	else
		Debug.MessageBox("Global Variable̖肪 [" + issuecount + "] o܂:\n\n")
		str += estr
		Debug.MessageBox(str)
		Utility.wait(0.1)
	endif	
	
	if (34 != TweakCombatOverridePackageList.GetSize())
		int size = TweakCombatOverridePackageList.GetSize()
		if (size < 34)
			Debug.MessageBox("TweakCombatOverridePackageListsK؂ł")
			Utility.wait(0.1)
		Else
			Debug.MessageBox("MODAFTCombatOverridesҏW܂B[" + size + "] overridesT|[gĂ܂")
			Utility.wait(0.1)
		EndIf
	EndIf
	
	TweakFollowerScript pTweakFollowerScript = ((self As Quest) As TweakFollowerScript)
	if (pTweakFollowerScript)
		ReferenceAlias[] followers = pTweakFollowerScript.GetAllTweakFollowers()
		int i = 0
		while i < followers.Length
			TweakSettings pTweakSettings = followers[i] As TweakSettings
			if pTweakSettings
				String name = pTweakSettings.originalName
				Actor npc = followers[i].GetActorRef()
				Package akPackage = npc.GetCurrentPackage()
				String pname = GetAFTPackageName(akPackage)
				if !pname
					Debug.MessageBox("x: tH[ [" + name + "] AFTȊOAI packagegpĂ܂:" + akPackage)
					Utility.wait(0.1)
				endif
			endif
			i += 1
		endwhile
	endif
	
EndFunction

Function Examine(ObjectReference onpc)

	TweakFollowerInfoScript pinfo = ((self As Quest) As TweakFollowerInfoScript)
	if (pinfo)
		pinfo.InfoStats(onpc)
		Utility.wait(0.1)
	endif

	Actor npc = onpc As Actor
	
	; Actor Values
	int favoractive = npc.GetAV("FavorActive") As Int
	int infamy = npc.GetAV("Infamy") As Int
	int fame = npc.GetAV("Fame") As Int
	int favorsperday = npc.GetAV("FavorsPerDay") As Int
	int favorsperdaytimer = npc.GetAV("FavorsPerDayTimer") As Int
	
	String str = ""
	if (0 == favoractive)
		str += "AFT ID (favoractive) [ǗĂ܂(0)]\n"
	elseif (favoractive < 32)
		str += "AFT ID (favoractive) [" + favoractive + "]\n"
	Else
		str += "AFT ID (favoractive) [sK؂Ȓl (" + favoractive + ")]\n"	
	endif	
	if (57339 == infamy)
		str += " (infamy) [True (57339)]\n"
	elseif (0 == infamy)
		str += " (infamy) [False (0)]\n"
	Else
		str += " (infamy) [sK؂Ȓl (" + infamy + ")]\n"
	endif
	if (9001 == fame)
		str += "{[iXi(fame) [True (9001)]\n"
	elseif (0 == fame)
		str += "{[iXi(fame) [False (0)]\n"
	Else
		str += "{[iXi(fame) [sK؂Ȓl (" + fame + ")]\n"
	endif
	if (97473 == favorsperday)
		str += "㩂̖ (favorsperday) [True (97473)]\n"
	elseif (0 == favorsperday)
		str += "㩂̖ (favorsperday) [False (0)]\n"
	Else
		str += "㩂̖ (favorsperday) [sK؂Ȓl (" + favorsperday + ")]\n"
	endif
	if (favorsperdaytimer > 730 && favorsperdaytimer < 739)
		String style = ""
		if 731 == favorsperdaytimer
			style = "@g"
		elseif 732 == favorsperdaytimer
			style = "@m"
		elseif 733 == favorsperdaytimer
			style = "Ў蕐"
		elseif 734 == favorsperdaytimer
			style = "蕐"
		elseif 735 == favorsperdaytimer
			style = "񓁗"
		elseif 736 == favorsperdaytimer
			style = "|"
		elseif 737 == favorsperdaytimer
			style = "W["
		endif
		str += "퓬X^C (favorsperdaytimer) [" + style + " (" + favorsperdaytimer + ")]\n"
	elseif (0 == favorsperdaytimer)
		str += "퓬X^C (favorsperdaytimer) [Ȃ (0)]\n"
	Else
		str += "퓬X^C (favorsperdaytimer) [sK؂Ȓl (" + favorsperdaytimer + ")]\n"
	endif

	; Weapon Info
	Bool weaponDrawn =  npc.IsWeaponDrawn()
	if weaponDrawn
		str += "̍\ [True]\n" 
	Else
		str += "̍\ [False]\n" 
	endif

	Form rightHand	 =	npc.GetEquippedWeapon()
	Form leftHand	 =	npc.GetEquippedWeapon(true)
	Form shield		 =	npc.GetEquippedShield()
	if (rightHand) ; right hand
		String weapType = "Ў蕐"
		if rightHand.HasKeyword(pWeapTypeGreatsword) || rightHand.HasKeyword(pWeapTypeBattleAxe)
			weapType = "蕐"
		elseif rightHand.HasKeyword(pArmorShield)			
			weapType = ""
		elseif rightHand.HasKeyword(pWeapTypeStaff)			
			weapType = ""
		elseif rightHand.HasKeyword(pWeapTypeBow)			
			weapType = "|"
		endif
		weapType += " [" + npc.GetBaseAV("rightitemcharge") + "/" + npc.GetAV("rightitemcharge") + "]\n"
		str += "E : " + weapType
	Else
		str += "E : Ȃ"
	endif
	if (leftHand)
		String weapType = "Ў蕐"
		if leftHand.HasKeyword(pWeapTypeGreatsword) || leftHand.HasKeyword(pWeapTypeBattleAxe)
			weapType = "蕐"
		elseif leftHand.HasKeyword(pArmorShield)			
			weapType = ""
		elseif leftHand.HasKeyword(pWeapTypeStaff)			
			weapType = ""
		elseif leftHand.HasKeyword(pWeapTypeBow)			
			weapType = "|"
		endif
		weapType += " [" + npc.GetBaseAV("leftitemcharge") + "/" + npc.GetAV("leftitemcharge") + "]\n"
		str += " : " + weapType
	else
		str += " : Ȃ\n"
	endif
	if (shield)
		str += " : " + shield
	else
		str += " : Ȃ\n"
	EndIf
	str += "REF [" + onpc + "]"

	Debug.MessageBox(str)
	Utility.wait(0.1)

	int leftType = npc.GetEquippedItemType(0)
	str = "蕐: [" 
	if (0 == leftType)
		str += "Ȃ"
	elseif (1 == leftType)
		str += "Ў茕"
	elseif (2 == leftType)
		str += "_K["
	elseif (3 == leftType)
		str += "Ў蕀"
	elseif (4 == leftType)
		str += "Ў胁CX"
	elseif (5 == leftType)
		str += "茕"
	elseif (6 == leftType)
		str += "蕀/胁CX"
	elseif (7 == leftType)
		str += "|"
	elseif (8 == leftType)
		str += ""
	elseif (9 == leftType)
		str += "@"
	elseif (10 == leftType)
		str += ""
	elseif (11 == leftType)
		str += "܂"
	elseif (12 == leftType)
		str += "NX{E"
	endif
	str += "]\n" 
	str += "E蕐: [" 
	int rightType = npc.GetEquippedItemType(1)
	if (0 == rightType)
		str += "Ȃ"
	elseif (1 == rightType)
		str += "Ў茕"
	elseif (2 == rightType)
		str += "_K["
	elseif (3 == rightType)
		str += "Ў蕀"
	elseif (4 == rightType)
		str += "Ў胁CX"
	elseif (5 == rightType)
		str += "茕"
	elseif (6 == rightType)
		str += "蕀/胁CX"
	elseif (7 == rightType)
		str += "|"
	elseif (8 == rightType)
		str += ""
	elseif (9 == rightType)
		str += "@"
	elseif (10 == rightType)
		str += ""
	elseif (11 == rightType)
		str += "܂"
	elseif (12 == rightType)
		str += "NX{E"
	endif
	str += "]\n" 
	
	if (npc.GetCurrentScene() == None)
		str += "Scene [Ȃ]\n"
	Else
		str += "Scene [" + npc.GetCurrentScene() + "]\n"
	endif
	
	Package akNewPackage = npc.GetCurrentPackage()
	String pname = GetAFTPackageName(akNewPackage)
	if pname
		str += pname
	else
		str += "pbP[W [" + akNewPackage + "]\n"
	endif
	
	if npc.IsDead()
		str += "S [TRUE] (Ăяos)\n"
	Else
		str += "S [FALSE]\n"
	endif
	if npc.IsUnconscious()
		str += "C [TRUE] (Ăяos)\n"
	Else
		str += "C [FALSE]\n"
	endif
	if onpc.IsDisabled()
		str += "gps [TRUE] (Ăяos)\n"
	Else
		str += "gps [FALSE]\n"
	endif
	if onpc.GetCurrentLocation()
		str += "ݒn [" + onpc.GetCurrentLocation() + "]\n"
	Else
		str += "ݒn [ps]\n"
	endif
	if onpc.GetParentCell()
		str += "݂̃Z [" + onpc.GetParentCell() + "]\n"		
	else
		str += "݂̃Z [ps]\n"
	endif
	
	Debug.MessageBox(str)
	Utility.wait(0.1)

EndFunction

String Function GetAFTPackageName(Package akNewPackage)
	if akNewPackage == TweakArcherPackage
		return "Package [TweakArcherPackage]\n"
	elseif akNewPackage == TweakArcherPackageExternal
		return "Package [TweakArcherPackageExternal]\n"
	elseif akNewPackage == TweakArcherPackageExternalLow 
		return "Package [TweakArcherPackageExternalLow]\n"
	elseif akNewPackage == TweakArcherPackageLow 
		return "Package [TweakArcherPackageLow]\n"
	elseif akNewPackage == TweakVLPackage 
		return "Package [TweakVLPackage]\n"
	elseif akNewPackage == TweakBeastPackage 
		return "Package [TweakBeastPackage]\n"
	elseif akNewPackage == pTweakDualPackage 
		return "Package [TweakDualPackage]\n"
	elseif akNewPackage == TweakDualPackageExterior 
		return "Package [TweakDualPackageExterior]\n"
	elseif akNewPackage == TweakDualPackageExteriorLow
		return "Package [TweakDualPackageExteriorLow]\n"
	elseif akNewPackage == TweakDualPackageLow
		return "Package [TweakDualPackageLow]\n"
	elseif akNewPackage == TweakGeneralPackage 
		return "Package [TweakGeneralPackage]\n"
	elseif akNewPackage == TweakGeneralPackageExterior 
		return "Package [TweakGeneralPackageExterior]\n"
	elseif akNewPackage == TweakGeneralPackageExteriorLow 
		return "Package [TweakGeneralPackageExteriorLow]\n"
	elseif akNewPackage == TweakGeneralPackageLow 
		return "Package [TweakGeneralPackageLow]\n"
	elseif akNewPackage == TweakMagePackage
		return "Package [TweakMagePackage]\n"
	elseif akNewPackage == TweakMagePackageExterior
		return "Package [TweakMagePackageExterior]\n"
	elseif akNewPackage == TweakMagePackageExteriorLow
		return "Package [TweakMagePackageExteriorLow]\n"
	elseif akNewPackage == TweakMagePackageLow
		return "Package [TweakMagePackageLow]\n"
	elseif akNewPackage == TweakRangerPackage
		return "Package [TweakRangerPackage]\n"
	elseif akNewPackage == TweakRangerPackageExterior
		return "Package [TweakRangerPackageExterior]\n"
	elseif akNewPackage == TweakRangerPackageExteriorLow 
		return "Package [TweakRangerPackageExteriorLow]\n"
	elseif akNewPackage == TweakRangerPackageLow 
		return "Package [TweakRangerPackageLow]\n"
	elseif akNewPackage == TweakSpellSwordPackage 
		return "Package [TweakSpellSwordPackage]\n"
	elseif akNewPackage == TweakSpellSwordPackageExterior 
		return "Package [TweakSpellSwordPackageExterior]\n"
	elseif akNewPackage == TweakSpellSwordPackageExteriorLow 
		return "Package [TweakSpellSwordPackageExteriorLow]\n"
	elseif akNewPackage == TweakSpellSwordPackageLow
		return "Package [TweakSpellSwordPackageLow]\n"
	elseif akNewPackage == TweakSwordAndShieldPackage 
		return "Package [TweakSwordAndShieldPackage]\n"
	elseif akNewPackage == TweakSwordAndShieldPackageExterior 
		return "Package [TweakSwordAndShieldPackageExterior]\n"
	elseif akNewPackage == TweakSwordAndShieldPackageExteriorLow 
		return "Package [TweakSwordAndShieldPackageExteriorLow]\n"
	elseif akNewPackage == TweakSwordAndShieldPackageLow 
		return "Package [TweakSwordAndShieldPackageLow]\n"
	elseif akNewPackage == TweakTwoHandedPackage
		return "Package [TweakTwoHandedPackage]\n"
	elseif akNewPackage == TweakTwoHandedPackageExterior 
		return "Package [TweakTwoHandedPackageExterior]\n"
	elseif akNewPackage == TweakTwoHandedPackageExteriorLow 
		return "Package [TweakTwoHandedPackageExteriorLow]\n"
	elseif akNewPackage == TweakTwoHandedPackageLow
		return "Package [TweakTwoHandedPackageLow]\n"
	elseif akNewPackage == pTweakFollowerSandbox
		return "Package [TweakFollowerSandbox]\n"
	elseif akNewPackage == pTweakFollowerNonAggressiveWaitPackage
		return "Package [TweakFollowerNAWaitPackage]\n"
	elseif akNewPackage == pTweakFollowerWaitPackage
		return "Package [TweakFollowerWaitPackage]\n"
	elseif akNewPackage == pTweakFollowerNonAggressivePackage
		return "Package [TweakFollowerNAPackage]\n"
	elseif akNewPackage == pTweakFollowerPackage
		return "Package [TweakFollowerPackage]\n"
	elseif akNewPackage == pTweakFollowerPackageGetOnHorse
		return "Package [TweakFollowerGetOnHorse]\n"
	elseif akNewPackage == pTweakFollowerPackageHorse
		return "Package [TweakFollowePackageHorse]\n"
	EndIf
	return None
EndFunction












